/*---------------------------------
Fred Paulino Ferreira - 47662
Exercicio de INF251
Multiplicador de n bits (n fornecido pelo usurio)
Funcao principal
12/10/2004
---------------------------------*/

#include<iostream.h>
#include<fstream.h>

//Prototipos das funcoes auxiliares
void carregaArqOrigem(int,int*);
void carregaArqDestino(int,int*);
void LigaFios(int &, fstream &);

int main(){

	int n=0, NumFio=0, posx=0, posy=0;

	fstream arq("multIntNBits.hds", ios::out);
	if(!arq){
		cout << "Error: Cannot open the file \"multIntNBits.hds\"" << endl;
		exit(-1);
	}
	
	cout << "Enter the  number of bits  ? ";
	cin >> n;
	
	if(n<=0){ //Digitou um numero de bits negativo
		cout << "Invalid number" << endl;
		exit(-1);
	}
	
	// Calcula a quantidade de bits a somar em cada coluna
	int x=2, bits[2*n-1]; // Vetor bits com tamanho igual ao numero de colunas a somar
	bits[0] = 1; // O vetor bits armazenara a quantidade bits a somar em cada coluna
	for(int i = 1 ; i < 2*n - 1 ; i++){
		bits[i] = x;
		if(i < n-1)	
			x+=2;
		else if(i == n)
			x--;
		else if(i >= n)
			x-=2;
	}

	arq << "# hades.models.Design file"
		 << "\n#"  
		 << "\n[name] multIntNBits"
		 << "\n[components]"
		 << "\nhades.models.rtlib.io.IpinVector ENTRADA_A 9900 2700 @N 1001 " << n << " UU_B 1.0E-9 0"
		 << "\nhades.models.rtlib.io.IpinVector ENTRADA_B 19800 2700 @N 1001 " << n << " UU_B 1.0E-9 0"	
		 << "\nhades.models.rtlib.io.Expander EXPANDER_A 10200 5100 @N 1001 " << n << " 1.0E-8"
		 << "\nhades.models.rtlib.io.Expander EXPANDER_B 20400 5100 @N 1001 " << n << " 1.0E-8"
		 << "\nhades.models.rtlib.io.MergeBits MERGE 5000 14000 @N 1001 " << ((n>1) ? 2*n : n) << " 1.0E-8"		 
		 << "\nhades.models.rtlib.io.OpinVector RESULTADO 5000 18000 @N 1001 " << ((n>1) ? 2*n : n) << " 1.0E-9 0";
		
	posx = 10200; 		 
	for(int i = 0 ; i < n ; i++) // Criando as portas AND
		for(int j = 0 ; j < n ; j++){
			arq << "\nhades.models.gates.And2 A" << j << "B" << i << " " << posx << " 9000 @N 1001 1.0E-8";
			posx += 4500;
		}
	
	// Constroi os soamdores
	int NumSom=0; // Numero do somador
	posx = 15000;
	posy = 15000;
	for(int i = 1 ; i < 2*n - 1 ; i++){
		for(int j = 0 ; j < ( bits[i] + bits[i] % 2 ) / 2 - 1 ; j++){
			arq << "\nhades.models.Design somador_" << NumSom++ << "_coluna_" << i << " " << posx << " " << posy
				 << " @N 1001 somador1bit_3Entradas.hds";

			posy += 4000;
		}
		if( bits[i] % 2 == 0 ){
			arq << "\nhades.models.Design somador_" << NumSom++ << "_coluna_" << i << " " << posx << " " << posy
				 << " @N 1001 somador1bit_2Entradas.hds";

		}
		NumSom = 0;
		posx += 4000;
		posy = 15000;
	}
	
	
	arq << "\n[end components]"
		 << "\n[signals]"
		 << "\nhades.signals.SignalStdLogicVector BARRAMENTO_A " << n << " 2 ENTRADA_A Y EXPANDER_A A 0 0"
		 << "\nhades.signals.SignalStdLogicVector BARRAMENTO_B " << n << " 2 ENTRADA_B Y EXPANDER_B A 0 0"
		 << "\nhades.signals.SignalStdLogicVector BARRAMENTO_C " << ((n>1) ? 2*n : n) << " 2 RESULTADO A MERGE Y 0 0";
	
	for(int i = 0 ; i < n ; i++){ // Liga o EXPANDER_A nas entradas A das portas AND
		arq << "\nhades.signals.SignalStdLogic1164 FIO_" << NumFio++ << " " << n + 1 << " EXPANDER_A Y" << i;		
		for(int j = 0 ; j < n ; j++)
			arq << " A" << i << "B" << j << " A";
		arq << " " << n << " 2 0";
	}
	
	for(int i = 0 ; i < n ; i++){ // Liga o EXPANDER_B nas entradas B das portas AND
		arq << "\nhades.signals.SignalStdLogic1164 FIO_" << NumFio++ << " " << n + 1 << " EXPANDER_B Y" << i;
		for(int j = 0 ; j < n ; j++)
			arq << " A" << j << "B" << i << " B";
		arq << " " << n << " 2 0";
	}	
	
	//Funcoes que armazenam a prigem e destino dos fios
	carregaArqOrigem(n,bits);
	carregaArqDestino(n,bits);

	//Liga um fio de uma origem a um destino
	LigaFios(NumFio, arq);

	arq << "\n[end signals]"
		 << "\n[end]" << endl;
	
	arq.close();
	return 0;
}




